#!/usr/bin/perl
#
#    Copyright (C) 2002 Sinclair InterNetworking Services Pty Ltd
#    <nmis@sins.com.au> http://www.sins.com.au/nmis
#
# 1. Checks all datafiles that should exist do exist
# 2. Checks files for the presence of the dreaded DOS ^M
# 3. Checks for the correct number of coliumns in each csv files
# 4. Checks for [TAB][TAB] or SPACE[TAB] or [TAB]SPACE in csv files

#my $inputfile=shift || &oops("No such file") ;
#my $counter=$0 ;


#*****************************************************************************
# Auto configure to the <nmis-base>/lib and <nmis-base>/files/nmis.conf
use FindBin;
use lib "$FindBin::Bin/../lib";
use lib "/usr/local/rrdtool/lib/perl";
use NMIS ;

# See if customised config file required.
my $conf;
if ( $nvp{file} ne "" ) { $conf = $nvp{file}; }
else { $conf = "nmis.conf"; }
my $configfile = "$FindBin::Bin/../conf/$conf";
if ( -r $configfile ) { loadConfiguration($configfile); }
# the following should be conformant to Linux FHS
elsif ( -e "/etc/nmis/$conf") { loadConfiguration ("/etc/nmis/$conf");}
else { die "Can't access neither configuration file $configfile, nor /etc/nmis/$conf \n"; }


$nmis_conf=$NMIS::config{'<nmis_conf>'} ;

print "### Checking files in $nmis_conf ###\n" ;

#@filelist=qw(events.csv logs.csv contacts.csv iftypes.csv nodes.csv links.csv enterprise.csv outage.dat escalation.csv locations.csv models.csv thresholds.csv nmis.conf users.dat) ; 

opendir (DIR, $nmis_conf );
@filelist = readdir DIR;
closedir DIR;

#@filelist=("buggered.csv","buggered.csv") ;

foreach $file (@filelist) {

	next if $file eq '.';			# skip dirs
	next if $file eq '..';
	next unless $file =~ /.csv/ ;	# only csv files with headers.

	$counter=0 ; 
	$errors=0 ;
	$headercount=0 ;
	$itemcount=0 ;

	$inputfile="$nmis_conf\/$file" ;

	open (IN,$inputfile) || warn "NMIS cannot open $inputfile.\n Check it exists and is readable as $inputfile" ;
	while (<IN>) {
		@itemcount=split(/\t/) ; 
		unless ($headercount) { 
			$headercount=$#itemcount ;
		}
		unless ($headercount == $#itemcount) {
			print "$file header has $headercount items but line $counter has $#itemcount items\n" ;
			$errors++ ;
		}
		$counter++ ;
		last if (/^#/) ;
	# Check for ^M characters and stop after the first one
        	if (/\r/) {
        		print "^M in line $counter of $inputfile\n$_\nStopping ^M checks of $inputfile\n. Use dos2unix.pl to fix this error then check it again\n" ;
			$errors++ ;
		# last ;
		}
	
	# Check for  [TAB][TAB] or SPACE[TAB] or [TAB]SPACE in csv files
	
        	if (/\t\t/) {
        		print "Two or more TABS in line $counter of $inputfile\n$_\n" ;
			$errors++ ;
		# last ;
		}	
        	if (/ \t/)  {
        		print "A SPACE before a TAB in line $counter of $inputfile\n$_\n" ;
			$errors++ ;
		# last ;
		}
        	if (/\t /)  {
        		print "A SPACE after a TAB in line $counter of $inputfile\n$_\n" ;
			$errors++ ;
		# last ;
		}
        	if (/ $/)  {
        		print "A trailing SPACE at the end of line $counter of $inputfile\n$_\n" ;
			$errors++ ;
		# last ;
		}
	} #	end of while loop

        unless ($errors) { $errors="No" ; }
        print "### $file - $errors Errors ###\n" ; 

} # end of foreach file @filelist
