#!/usr/bin/perl
#
#    nmis.pl - NMIS Perl Program - Network Mangement Information System
#    Copyright (C) 2000 Sinclair InterNetworking Services Pty Ltd
#    <nmis@sins.com.au> http://www.sins.com.au/nmis
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# *****************************************************************************

# Auto configure to the <nmis-base>/lib and <nmis-base>/files/nmis.conf
use FindBin;
use lib "$FindBin::Bin/../lib";
# 
# ****** Shouldn't be anything else to customise below here *******************
# best to customise in the nmis.conf file.
#

require 5;

use strict;
use NMIS;
use func;



my %nvp = getArguements(@ARGV);

use Config::General;
use Data::Dumper;
$Data::Dumper::Indent = 1;

my $node='testnode';
my $datestamp_start="dstart";
my $datestamp_end="dend";
my $start="start";
my $end="end";
my $width="width";
my $height="height";
my $database = '/nmis/test';
my $length="length";
my %config;



%config = ParseConfig(-ConfigFile => "$nvp{file}");		# read the config file in config::general format - contains $var

my @options = @{ $config{rrd} };		# simple assignment - does not interpolate $var

foreach ( @{ $config{rrd} } ) {			# eval each $var as we find them, assuming $var exists, will interpolate, or throw an error
        s/(\$\w+)/(eval $1)/eg;
        warn "Failed to eval() file \$config{rrd}\n$@\n" if ($@);
        $@="";
}


print "array now has real values\n";
print Dumper(\%config);
print "array does not have real values\n";
print Dumper(\@options);

=pod
rcfile looks like this..
exmaple of how an rrd definition table may look..in config::general syntax
could also be xml.

rrd   "--title"
rrd   "$node - $length from $datestamp_start to $datestamp_end"
rrd   "--vertical-label"
rrd   "Server Temperature"
rrd   "--start"
rrd   "$start"
rrd   "--end"
rrd   "$end"
rrd   "--width"
rrd   "$width"
rrd   "--height"
rrd   "$height"
rrd   "--imgformat"
rrd   "PNG"
rrd   "--interlace"
rrd   "DEF:tempReading=$database:tempReading:AVERAGE"
rrd   "DEF:tempMinWarn=$database:tempMinWarn:AVERAGE"
rrd   "DEF:tempMaxWarn=$database:tempMaxWarn:AVERAGE"
rrd   "CDEF:xtempReading=tempReading,10,/"
rrd   "CDEF:xtempMinWarn=tempMinWarn,10,/"
rrd   "CDEF:xtempMaxWarn=tempMaxWarn,10,/"
rrd   "LINE2:xtempReading\#00ff00:Avg Temp"
rrd   "LINE1:xtempMinWarn\#0000ff:Min Alarm Temp"
rrd   "LINE1:xtempMaxWarn\#ff0000:Max Alarm Temp"
rrd   "GPRINT:xtempReading:AVERAGE:Avg Temp %1.2lf Deg."
rrd   "GPRINT:xtempReading:MAX:Max Temp %1.2lf Deg."




=cut



