#!/usr/bin/perl
#
#    run-nmis.pl - NMIS Perl Program - Network Management Information System
#    Copyright (C) 2000 Sinclair InterNetworking Services Pty Ltd
#    <nmis@sins.com.au> http://www.sins.com.au/nmis
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#*****************************************************************************
use strict;
use FindBin;
use lib "$FindBin::Bin/../lib";
use func;
my $interval = 300;
my $update = 86400;
my $nmis_update = "$FindBin::Bin/nmis.pl type=update debug=1";
my $nmis_collect = "$FindBin::Bin/nmis.pl type=collect debug=1";
my $nmis_thresh = "$FindBin::Bin/nmis.pl type=threshold debug=0";
my $first = 1;
while (1) { 
	if ( time() % ($interval * 3) == 0 ) {
		print returnDateStamp." Test $interval x 3\n"
	}

	if ( ! $first ) {
		sleep( $interval - time() % $interval );
	} else {
		$first = 0;
		system "$nmis_update";
	}
	print returnDateStamp." NMIS Collect: $nmis_collect\n";
	system "$nmis_collect";

	print returnDateStamp." NMIS Threshold: $nmis_thresh\n";
	system "$nmis_thresh";


	# So update once every 86400 seconds.
	print returnDateStamp." Done!\n";
}

# Add support for kicking off all NMIS processes!
