#!/usr/bin/ksh
#
#    run-reports.sh - NMIS CGI Program - Network Mangement Information System
#    Copyright (C) 2000 Sinclair InterNetworking Services Pty Ltd
#    <nmis@sins.com.au> http://www.sins.com.au/nmis

export PATH=/usr/bin:/usr/sbin:/usr/ucb:/usr/local/bin:/usr/local/nagios/nmis/bin:/bin
cd /usr/local/nagios/nmis/bin

log=/usr/local/nagios/nmis/log/reports.log
reportdir=/usr/local/nagios/nmis/htdocs/reports

# set the date parameters
year=`date | awk '{print $6}'`
month=`date | awk '{print $2}'|cut -c 1-3`
weekday=`date | awk '{print $1}'|cut -c1-3`
day=`date | awk '{print $3}'`
time=`date | awk '{print $4}'`

case $month in
	Jan)	month=01
		lastmonth=12;;
	Feb)	month=02
		lastmonth=01;;
	Mar)	month=03
		lastmonth=02;;
	Apr)	month=04
		lastmonth=03;;
	May)	month=05
		lastmonth=04;;
	Jun)	month=06
		lastmonth=05;;
	Jul)	month=07
		lastmonth=06;;
	Aug)	month=08
		lastmonth=07;;
	Sep)	month=09
		lastmonth=08;;
	Oct)	month=10
		lastmonth=09;;
	Nov)	month=11
		lastmonth=10;;
	Dec)	month=12
		lastmonth=11;;
esac

case $day in
	1) day=01;;
	2) day=02;;
	3) day=03;;
	4) day=04;;
	5) day=05;;
	6) day=06;;
	7) day=07;;
	8) day=08;;
	9) day=09;;
esac

date="$day-$month-$year"     


case $1 in
	month) 	length=month
	     	outfile=month-$lastmonth-$year.html
		;;
	day) 	length=day
	     	outfile=day-$day-$month-$year-$weekday.html
		;;
	week) 	length=week
	     	outfile=week-$day-$month-$year-$weekday.html
		;;
	*)
		echo Requires type argument month, week or day
		;;
esac

case $2 in
	health) 
		../cgi-bin/reports.pl report=$2 length=$length outfile=$reportdir/$outfile
		chmod 664 $reportdir/$outfile
		chgrp nagios $reportdir/$outfile
		chown nagios $reportdir/$outfile
		;;
	outage)
		../cgi-bin/reports.pl report=$2 length=$length outfile=$reportdir/outage-$outfile
		chmod 664 $reportdir/outage-$outfile
		chgrp nagios $reportdir/outage-$outfile
		chown nagios $reportdir/outage-$outfile
		;;
	response)
		../cgi-bin/reports.pl report=$2 length=$length outfile=$reportdir/response-$outfile
		chmod 664 $reportdir/response-$outfile
		chgrp nagios $reportdir/response-$outfile
		chown nagios $reportdir/response-$outfile
		;;
	top10)
		../cgi-bin/reports.pl report=$2 length=$length outfile=$reportdir/top10-$outfile
		chmod 664 $reportdir/top10-$outfile
		chgrp nagios $reportdir/top10-$outfile
		chown nagios $reportdir/top10-$outfile
		;;
	avail)
		../cgi-bin/reports.pl report=$2 length=$length outfile=$reportdir/avail-$outfile
		chmod 664 $reportdir/avail-$outfile
		chgrp nagios $reportdir/avail-$outfile
		chown nagios $reportdir/avail-$outfile
		;;
	port)
		../cgi-bin/reports.pl report=$2 length=$length outfile=$reportdir/port-$outfile
		chmod 664 $reportdir/port-$outfile
		chgrp nagios $reportdir/port-$outfile
		chown nagios $reportdir/port-$outfile
		;;

	*)
		echo Requires type argument response, health , top10, avail, port or outage
		;;
esac


exit 0
