#!/usr/bin/perl

use FindBin;
use lib "$FindBin::Bin/../lib";
use lib "/usr/local/rrdtool/lib/perl"; 


use strict;
use csv;
use BER;
use SNMP_Session;
use SNMP_MIB;
use SNMP_Simple;
use SNMPv2c_Simple;
use SNMP_util;
use RRDs;
use rrdfunc;
use NMIS;
use func;
use ip;
use ping;
use notify;
use sapi;
use masterslave;

	require Data::Dumper;
	Data::Dumper->import();
	$Data::Dumper::Indent = 1;


# See if customised config file required.
my $conf = "nmis.conf";
my $configfile = "$FindBin::Bin/../conf/$conf";
if ( -r $configfile ) { loadConfiguration($configfile); }
# the following should be conformant to Linux FHS
elsif ( -e "/etc/nmis/$conf") { loadConfiguration ("/etc/nmis/$conf");}
else { die "Can't access neither configuration file $configfile, nor /etc/nmis/$conf \n"; }

my %nvp = getArguements(@ARGV);



loadNodeDetails;

$NMIS::debug='true';
my $ds = 'DS:loss:GAUGE:900:0:100';

if ( $nvp{node} ) {
	my $database = getRRDFileName(node => $nvp{node}, group => $NMIS::nodeTable{$nvp{node}}{group}, nodeType => $NMIS::nodeTable{$nvp{node}}{devicetype} , type => "reach");
	&addDStoRRD($database,$ds); # sub in rrdfunc
}
else {


	foreach ( keys %NMIS::nodeTable ) {
		my $database = getRRDFileName(node => $_, group => $NMIS::nodeTable{$_}{group}, nodeType => $NMIS::nodeTable{$_}{devicetype} , type => "reach");
		&addDStoRRD($database,$ds); # sub in rrdfunc
		NMIS::setFileProt($database);
	}
}














