/*i
 * Fabtabulous! Simple tabs using Prototype
 * http://tetlaw.id.au/view/blog/fabtabulous-simple-tabs-using-prototype/
 * Andrew Tetlaw
 * version 1.1 2006-05-06
 * http://creativecommons.org/licenses/by-sa/2.5/
 */
var Fabtabs = Class.create();

Fabtabs.prototype = {
	initialize : function(element, initialTab) {
		this.element = $(element);
		if (this.element) {
			var options = Object.extend({}, arguments[1] || {});
			this.menu = $A(this.element.getElementsByTagName('a'));
			this.show(this.getInitialTab(initialTab));
			this.menu.each(this.setupTab.bind(this));
		}
	},
	setupTab : function(elm) {
		Event.observe(elm,'click',this.activate.bindAsEventListener(this),false)
	},
	activate :  function(ev) {
                // only switch if tab is valid 
                if (typeof globalValidator == "undefined" || globalValidator.validate($(this.tabID(this.getActiveTab())))) {
		    var elm = Event.findElement(ev, "a");
		    this.show(elm);
		    this.menu.without(elm).each(this.hide.bind(this));
                }
		Event.stop(ev);
	},
	hide : function(elm) {
		$(elm).removeClassName('active-tab');
		$(this.tabID(elm)).removeClassName('active-tab-body');
	},
	show : function(elm) {
		$(elm).addClassName('active-tab');
		$(this.tabID(elm)).addClassName('active-tab-body');

	},
	tabID : function(elm) {
		return elm.href.match(/#([\w-]+)/)[1];
	},
	getInitialTab : function(tabname) {
		if (! tabname) {
			document.location.href.match(/#([\w-]+)/);
			tabname = RegExp.$1;
		}
		if(tabname) {
			var elm = this.menu.find(function(value) { return value.href.match(/#([\w-]+)/)[1] == tabname; });
			return elm || this.menu.first();
		} else {
			return this.menu.first();
		}
	}
,
        getActiveTab : function() {
            return this.menu.find(function(value) { return value.hasClassName('active-tab'); }); 
        }
}
//Initialise with:
//Event.observe(window,'load',function(){ new Fabtabs('tabs'); },false);
